// Main stuff.

if not WindowsTheComputer then return end
freeslot("SFX_WINCBT", "SFX_WINXBT", "SFX_WINRBT", "SFX_HVRJMP", "SFX_PINBL1", "SFX_SPSLRI",
		 "SFX_MMEPOP", "SFX_UIHMSN", "SFX_PINBL2", "SFX_PINBL3", "SFX_INURPC", "SFX_512600",
		 "SFX_502195", "SFX_501946", "SFX_606000", "SFX_IRBGIN", "SFX_HVRRES", "SFX_WIN98T",
		 "SFX_CPANEL", "SKINCOLOR_WINSTANDARD", "SKINCOLOR_WINCLASSIC",
		 "SKINCOLOR_98ARCHITECTURE", "SKINCOLOR_98CITYSCAPE", "SKINCOLOR_98WORLDTRAVEL",
		 "SKINCOLOR_BLACKCOMB", "SKINCOLOR_NEWERAPC", "S_WIN_CLR", "S_WIN_CLR1")

states[S_WIN_CLR] = {SPR_PLAY, SPR2_FLY_|FF_ANIMATE, 25, nil, 11, 3, S_WIN_CLR1}
states[S_WIN_CLR1] = {SPR_PLAY, SPR2_GLID, 5, nil, 0, 0, S_WIN_CLR1}

sfxinfo[sfx_wincbt] = {
	singular = false,
	priority = 50,
	caption = "DirectX Boost"
}

sfxinfo[sfx_winxbt] = {
	singular = false,
	priority = 51,
	caption = "DirectX Boost"
}

sfxinfo[sfx_winrbt] = {
	singular = false,
	priority = 50,
	caption = "DirectX Ready"
}

sfxinfo[sfx_hvrjmp] = {
	singular = false,
	priority = 50,
	caption = "Hover! Jump"
}

sfxinfo[sfx_hvrres] = {
	singular = false,
	priority = 50,
	caption = "Hover! Restore Flag"
}

sfxinfo[sfx_pinbl1] = {
	singular = false,
	priority = 50,
	caption = "Space Cadet Launch"
}

sfxinfo[sfx_pinbl2] = {
	singular = false,
	priority = 50,
	caption = "Space Cadet Thrust"
}

sfxinfo[sfx_pinbl3] = {
	singular = false,
	priority = 50,
	caption = "LOSE BALL"
}

sfxinfo[sfx_inurpc] = {
	singular = false,
	priority = 50,
	caption = "Inside Your Computer Minimize"
}

sfxinfo[sfx_spslri] = {
	singular = false,
	priority = 98,
	caption = "Restore Point Get"
}

sfxinfo[sfx_mmepop] = {
	singular = false,
	priority = 50,
	caption = "Bubble Wasted"
}

sfxinfo[sfx_uihmsn] = {
	singular = true,
	priority = 100,
	flags = SF_TOTALLYSINGLE,
	caption = "Setting Changed"
}

sfxinfo[sfx_win98t] = {
	singular = false,
	priority = 50,
	caption = "tada.wav"
}

sfxinfo[sfx_cpanel] = {
	singular = false,
	priority = 50,
	caption = "Config Access Successful"
}

skincolors[SKINCOLOR_WINSTANDARD] = {
	name = "Windows Standard",
	ramp = {146,146,170,170,170,171,171,171,172,172,173,173,173,174,174,138},
	invcolor = SKINCOLOR_YOGURT,
	invshade = 9,
	chatcolor = V_AZUREMAP,
	accessible = true
}

skincolors[SKINCOLOR_WINCLASSIC] = {
	name = "Windows Classic",
	ramp = {133,134,135,135,135,136,136,136,137,137,137,137,138,138,159,159},
	invcolor = SKINCOLOR_BROWN,
	invshade = 9,
	chatcolor = V_AZUREMAP,
	accessible = true
}

skincolors[SKINCOLOR_98ARCHITECTURE] = {
	name = "Architecture",
	ramp = {221,221,222,222,223,224,224,225,226,227,228,68,68,69,69,70},
	invcolor = SKINCOLOR_YOGURT,
	invshade = 9,
	chatcolor = V_BROWNMAP,
	accessible = true
}

skincolors[SKINCOLOR_98CITYSCAPE] = {
	name = "Cityscape",
	ramp = {146,147,147,148,148,148,149,149,149,150,150,150,154,155,156,157},
	invcolor = SKINCOLOR_RUST,
	invshade = 9,
	chatcolor = V_AZUREMAP,
	accessible = true
}

skincolors[SKINCOLOR_98WORLDTRAVEL] = {
	name = "World Traveler",
	ramp = {147,170,170,171,171,172,172,172,196,196,197,197,186,198,187,187},
	invcolor = SKINCOLOR_LIME,
	invshade = 9,
	chatcolor = V_PURPLEMAP,
	accessible = true
}

skincolors[SKINCOLOR_BLACKCOMB] = {
	name = "Blackcomb",
	ramp = {128,129,129,130,132,134,134,135,135,136,136,137,137,137,138,138},
	invcolor = SKINCOLOR_PEACHY,
	invshade = 1,
	chatcolor = V_SKYMAP,
	accessible = true
}

// Special animated skincolor!
skincolors[SKINCOLOR_NEWERAPC] = {
	name = "Dawn of a New Era",
	ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	invcolor = SKINCOLOR_WHITE,
	invshade = 9,
	chatcolor = V_INVERTMAP,
	accessible = true
}

local WhereDoYouWantToGoToday = {
	{25,25,26,26,26,27,27,28,28,28,29,29,30,30,31,31}, // Black
	{44,44,44,45,45,71,71,46,46,47,47,47,47,47,30,31}, 
	{39,39,40,41,41,42,42,43,44,44,45,71,46,46,47,47},
	{35,36,37,38,38,39,40,41,42,43,44,45,71,46,47,47},
	{32,33,33,34,34,35,35,37,39,40,42,44,71,47,30,31}, // Red
	{35,36,37,38,38,39,40,41,42,43,44,45,71,46,47,47},
	{39,39,40,41,41,42,42,43,44,44,45,71,46,46,47,47},
	{44,44,44,45,45,71,71,46,46,47,47,47,47,47,30,31},
	{25,25,26,26,26,27,27,28,28,28,29,29,30,30,31,31}, // Black
	{116,116,116,117,117,117,117,118,118,118,119,119,111,111,31,31},
	{114,115,115,115,116,116,116,117,117,117,118,118,119,119,119,111},
	{113,114,114,114,115,115,116,116,116,117,117,118,118,119,119,111},
	{112,112,113,113,114,114,115,115,116,116,117,117,118,118,119,111}, // Green
	{113,114,114,114,115,115,116,116,116,117,117,118,118,119,119,111},
	{114,115,115,115,116,116,116,117,117,117,118,118,119,119,119,111},
	{116,116,116,117,117,117,117,118,118,118,119,119,111,111,31,31},
	{25,25,26,26,26,27,27,28,28,28,29,29,30,30,31,31}, // Black
	{138,138,138,139,139,139,139,139,139,254,254,254,30,30,31,31},
	{136,136,136,137,137,137,138,138,138,138,139,139,254,254,30,31},
	{135,135,135,136,136,136,136,137,137,137,138,138,138,159,139,139},
	{133,133,134,135,135,136,136,137,137,137,138,138,138,139,139,139}, // Blue
	{135,135,135,136,136,136,136,137,137,137,138,138,138,159,139,139},
	{136,136,136,137,137,137,138,138,138,138,139,139,254,254,30,31},
	{138,138,138,139,139,139,139,139,139,254,254,254,30,30,31,31},
	{25,25,26,26,26,27,27,28,28,28,29,29,30,30,31,31}, // Black
	{79,79,79,79,237,238,238,239,239,239,239,110,110,111,111,31},
	{77,77,77,77,78,78,78,79,79,79,79,237,238,239,239,239},
	{75,75,76,76,76,77,77,78,78,79,79,79,237,238,239,239},
	{72,74,74,75,75,76,76,77,77,78,78,79,79,238,239,110}, // Yellow
	{75,75,76,76,76,77,77,78,78,79,79,79,237,238,239,239},
	{77,77,77,77,78,78,78,79,79,79,79,237,238,239,239,239},
	{79,79,79,79,237,238,238,239,239,239,239,110,110,111,111,31}
}

// Animating the skincolor...
local iter = 1
local hellomrce = false
addHook("ThinkFrame", do
	if leveltime%5 == 0 or (hellomrce and leveltime%2 == 0) then
		iter = $+1
		if iter > #WhereDoYouWantToGoToday then
			iter = 1
		end
	end
	skincolors[SKINCOLOR_NEWERAPC].ramp = WhereDoYouWantToGoToday[iter]
end)

if srb2p then return end

local function controlpanel()
	S_StartSound(nil, sfx_uihmsn, consoleplayer)
end

local cobalt = false

for player in players.iterate
	player.winpopup = 10*TICRATE
	player.cpanel = 0
	player.xpcooldown = 60*TICRATE
	player.fundeath = 0
	player.canxpblast = true
	player.wintro = true
	player.iswindows = false
	player.defragment = false
	player.hasfundie = false
	player.tada98 = false
	player.dxhudshift = 0
	player.dxhudalt = false
	player.oldbie = 0
	player.newbie = 0
	player.ohbig = 0
	player.xpbliss = false
	player.formnet = 0
	player.filetossallow = false
	player.legoislandcd = false
	player.sparkspawn = false
end

local directxboost = CV_RegisterVar({ // Toggle for the miniboost ability.
	name = "DirectX",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,
	PossibleValue = {disabled=0, enabled=1},
	func = controlpanel
})

local mobjscale = CV_RegisterVar({ 
	name = "kartgrow",							// Console variable to keep track
	defaultvalue = 1,							// for speed shoes replacement
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,	// mechanic straight from SRB2Kart.
	PossibleValue = {disabled=0, enabled=1},
	func = controlpanel
})

// Set up a value to check against for custom jingles.
local mplayer = CV_RegisterVar({
	name = "canyon.mid",
	defaultvalue = 1,
	flags = CV_SHOWMODIF | CV_CALL,
	PossibleValue = {default=0, custom=1},
	func = controlpanel
})

// Windows destroys bubbles... by default, anyway.
local bubblegrief = CV_RegisterVar({
	name = "winbubble",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,
	PossibleValue = {disabled=0, enabled=1},
	func = controlpanel
})

local isdebug = CV_RegisterVar({
	name = "windbg",
	defaultvalue = 0,
	flags = CV_SHOWMODIF | CV_CALL,
	PossibleValue = {off=0, on=1},
	func = controlpanel
})

// Players can be given free reign of their own super colors if need be.
COM_AddCommand("xpsuper", function(player, arg)
	if arg then
		arg = arg:lower()
		if arg == "1" or arg == "force" or arg == "lock" then
			player.xpsuper = true
			CONS_Printf(player, "Windows forces a Super color.")
			S_StartSound(nil, sfx_uihmsn, player)
		elseif arg == "0" or arg == "unlock" then
			player.xpsuper = false
			CONS_Printf(player, "Windows no longer forces a Super color.")
			S_StartSound(nil, sfx_uihmsn, player)
		end
	else
		if (player.isxmomentum and not player.xmomtoggledoff) then
			CONS_Printf(player, "By default, Windows, when Super/Hyper, has a forced skincolor.")
		else
			CONS_Printf(player, "By default, Windows, when Super, has a forced skincolor.")
		end
		CONS_Printf(player, "If you don't want that, add '0' or 'unlock' to this command.")
		CONS_Printf(player, "To revert back to default, use '1' or 'force' instead.")
	end
end)

// Basic, buggy Sol Emerald support.
COM_AddCommand("xpsol", function(player, arg)
	if not solchars then
		CONS_Printf(player, "You do not have RushChars v1.1 or higher loaded.")
		S_StartSound(player.mo, sfx_noxmom, player)
		return
	end
	if arg then
		arg = arg:lower()
		if (arg == "enable" or arg == "1") and solchars and not player.solchar then
			solchars["windows"] = {SKINCOLOR_BLACKCOMB, 3}
			CONS_Printf(player, "Windows can now use Sol Emeralds.")
			S_StartSound(nil, sfx_uihmsn, player)
		elseif (arg == "disable" or arg == "0") and solchars and player.solchar then
			solchars["windows"] = nil
			CONS_Printf(player, "Windows can no longer use Sol Emeralds.")
			S_StartSound(nil, sfx_uihmsn, player)
		end
	else
		CONS_Printf(player, "By default, Windows can't use Sol Emeralds, although")
		CONS_Printf(player, "you can add 'enable' to this command to change that.")
		CONS_Printf(player, "Note that it might be quite buggy.")
	end
end, COM_ADMIN)

// Support for Sol Emerald transformation is present.
// This is merely a safeguard against potential spamming
// of transformations.
addHook("PlayerCmd", function(player, cmd)
	if (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		if player.solchar and cmd.buttons & BT_SPIN and player.solchar.hasallemeralds and player.powers[pw_super] != 0 then
			player.solchar.spindown = true
		end
	end
end)

// Converted function overrides into a friendly hook.
// Invincibility and Growth are instant on use in Kart anyway...
addHook("MobjDeath", function(box, inflictor, source)
	if (inflictor and inflictor.valid) and (source and source.valid and source.player and source.skin == "windows") then
		local win = source.player
		if (box.type == MT_SNEAKERS_BOX or box.type == MT_SNEAKERS_GOLDBOX) then
			if mobjscale.value and not (win.solchar and win.solchar.istransformed and win.solchar.istransformed > 1) then
				if not win.ohbig then
					win.oldbie = win.mo.scale
					win.newbie = win.mo.scale*2
					win.mo.destscale = win.newbie
					win.ohbig = true
				end
				if win.powers[pw_super] != 0 then
					win.powers[pw_sneakers] = $ + sneakertics + 1
					if not (win.isxmomentum != nil and win.hyper and win.hyper.capable) and S_MusicName(win) != "_1up" then
						if mariomode then S_ChangeMusic("KGROWM", true, win)
						else S_ChangeMusic("KGROW", true, win) end
						if win.solchar then win.solchar.musicplaying = 0 end
					end
				else
					win.powers[pw_sneakers] = $ + ((3*sneakertics) / 5)
					if S_MusicName(win) != "_1up" then
						if mariomode then S_ChangeMusic("KGROWM", true, win)
						else S_ChangeMusic("KGROW", true, win) end
						if win.solchar then win.solchar.musicplaying = 0 end
					end
				end
				S_StartMusicCaption("Growth Powerup", win.powers[pw_sneakers], win)
				S_StartSound(source, sfx_kc5a)
			elseif not mobjscale.value and not (win.solchar and win.solchar.istransformed and win.solchar.istransformed > 1)
				win.powers[pw_sneakers] = $ + sneakertics + 1
				if win.powers[pw_super] == 0 then
					if S_MusicName(win) != "_1up" then
						if mplayer.value == 1 then
							P_PlayJingleMusic(win, "WINFAST", 0, true, JT_SHOES)
						else
							P_PlayJingle(win, JT_SHOES)
						end
						if win.solchar then win.solchar.musicplaying = 0 end
						S_StartMusicCaption("Speed Shoes", win.powers[pw_sneakers], win)
					end
				end
			end
			if (win.solchar and win.solchar.istransformed and win.solchar.istransformed > 1) then S_StartSound(win.mo, sfx_noxmom, win) end
			box.target = nil
			P_KillMobj(box)
			return true
		elseif (box.type == MT_INVULN_BOX or box.type == MT_INVULN_GOLDBOX) then
			win.powers[pw_invulnerability] = $ + invulntics + 1
			if (mobjscale.value == 1 and win.powers[pw_sneakers] != 0) or win.powers[pw_super] != 0 then
				box.target = nil
				P_KillMobj(box)
				return true
			else
				if S_MusicName(win) != "_1up" then
					if mplayer.value == 1 then
						if mariomode and S_MusicName(win) != "kinv" then P_PlayJingleMusic(win, "KINV", 0, true, JT_INV)
						else if S_MusicName(win) != "winv" and not mariomode then P_PlayJingleMusic(win, "WINV", 0, true, JT_INV) end
						end
					else
						if mariomode then P_PlayJingleMusic(win, "_MINV", 0, true, JT_INV)
						else P_PlayJingle(win, JT_INV) end
					end
					if win.solchar then win.solchar.musicplaying = 0 end
					S_StartMusicCaption("Invincibility", win.powers[pw_invulnerability], win)
				end
			end
			box.target = nil
			P_KillMobj(box)
			return true
		elseif (box.type == MT_RING_BOX or box.type == MT_RING_REDBOX or box.type == MT_RING_BLUEBOX) then
			if win.winpopup < 10*TICRATE then win.winpopup = $ + 5*TICRATE/2 end
			P_GivePlayerRings(win, 10)
			S_StartSound(source, sfx_itemup, win)
			box.target = nil
			P_KillMobj(box)
			return true
		end
	end
end)

addHook("PlayerSpawn", function(player)
	player.winpopup = 10*TICRATE
	player.cpanel = 0
	player.xpcooldown = 60*TICRATE
	player.fundeath = 0
	player.dxready = true
	player.xpready = true
	player.defragment = false
	if player.wintro == nil then player.wintro = true end
	if player.mo and player.mo.valid and player.mo.skin == "windows" then player.iswindows = true else player.iswindows = false end
	player.hasfundie = false
	player.tada98 = false
	if player.dxhudshift == nil then player.dxhudshift = 0 end
	if player.dxhudalt == nil then player.dxhudalt = false 
	elseif player.dxhudalt then player.dxhudshift = 16 end
	if player.oldbie == nil then player.oldbie = player.mo.destscale end
	if player.mo.destscale > player.oldbie then player.mo.destscale = player.oldbie end
	player.newbie = player.mo.destscale*2
	player.ohbig = false
	if player.xpsuper == nil then player.xpsuper = true end
	player.formnet = TICRATE
	if G_PlatformGametype() or (CBW_Battle and not G_PlatformGametype()) then player.filetossallow = true else player.filetossallow = false end
	player.legoislandcd = false
	player.sparkspawn = false
	if player.mrce then
		if gamemap == 164 and not netgame then
			hellomrce = true
			if (mrce_hyperunlocked) or ((player.isxmomentum and not player.xmomtoggledoff) and not (player.hyper and player.hyper.capable)) then
				if player.isxmomentum and player.hyper and not player.hyper.capable then
					player.hyper.capable = true
					player.rings = 95
				end
			end
		else
			hellomrce = false
		end
	end
end)

// Main batch.
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin != "windows" then
		if player.iswindows then
			if mobjscale.value == 1 and player.powers[pw_sneakers] != 0 then
				player.mo.destscale = FRACUNIT
				P_RestoreMusic(player)
				P_ResetPlayer(player)
			end
			if player.winpopup == nil then player.winpopup = 10*TICRATE 
			else player.winpopup = 10*TICRATE end
			if player.xpcooldown == nil then player.xpcooldown = 60*TICRATE 
			else player.xpcooldown = 60*TICRATE end
			if player.fundeath == nil then player.fundeath = 0 end
			player.iswindows = false
			if player.filetossallow then player.filetossallow = false end
		end
	elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		// XMomentum stuff.
		if G_PlatformGametype() or (CBW_Battle and not G_PlatformGametype()) then player.filetossallow = true else player.filetossallow = false end
		if player.isxmomentum != nil then
			if mplayer.value == 1 then player.hassupermusic = true else player.hassupermusic = false end
			player.spcanflip = false
		end
		if P_IsObjectOnGround(player.mo) then
			if FixedMul(player.speed, player.mo.scale) > 20*FRACUNIT and player.cpanel > 0 then
				if player.radius != nil then
					P_SpawnSkidDust(player, player.radius)
				end
			end
			if FixedMul(player.speed, player.mo.scale) < 5*FRACUNIT or (FixedMul(player.speed, player.mo.scale) < 10*FRACUNIT and player.powers[pw_super] != 0) then
				if (player.pflags & (PF_SPINNING)) then player.pflags = $ & ~PF_SPINNING end
				if player.panim == PA_ROLL then player.mo.state = S_PLAY_WALK end
			end
			player.cpucooler = false
			if player.defragment and not (player.pflags & (PF_SPINNING)) then player.defragment = false end
		end
		if player.pflags & PF_STARTJUMP and player.defragment then player.defragment = false end
		player.accelstart = skins[player.mo.skin].accelstart
		player.acceleration = skins[player.mo.skin].acceleration
		player.thrustfactor = skins[player.mo.skin].thrustfactor
		player.jumpfactor = skins[player.mo.skin].jumpfactor + (player.speed / 100)
		if (FixedMul(player.speed, player.mo.scale) > 20*FRACUNIT and player.powers[pw_super] == 0) or player.powers[pw_super] != 0 or player.powers[pw_invulnerability] != 0 or player.cpanel > 0 then
			player.charflags = $ | SF_CANBUSTWALLS // Ram into the wall!
		else
			player.charflags = $ & ~SF_CANBUSTWALLS
		end
		if player.powers[pw_invulnerability] != 0 and player.powers[pw_sneakers] == 0 then
			player.acceleration = (skins[player.mo.skin].acceleration * 3) / 2
			player.accelstart = (skins[player.mo.skin].accelstart * 3) / 2
		elseif player.powers[pw_sneakers] != 0 then
			if mobjscale.value == 1 then
				if not player.ohbig then player.ohbig = true end
				if player.powers[pw_invulnerability] < player.powers[pw_sneakers] and not (player.mrce and player.powers[pw_super]) then
					player.powers[pw_invulnerability] = player.powers[pw_sneakers]
				end
			else // Else, not much excitement.
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 5) / 4
			end
		end
		if player.powers[pw_sneakers] > 0 and player.ohbig and mobjscale.value then
			player.mo.destscale = player.newbie
		elseif (player.powers[pw_sneakers] == 0 and player.ohbig and mobjscale.value)
		or (player.powers[pw_sneakers] > 0 and player.ohbig and not mobjscale.value) then
			player.mo.destscale = player.oldbie
			player.ohbig = false
		end
		if player.powers[pw_super] != 0 or (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1) then
			if player.powers[pw_super] != 0 then
				player.charflags = $ | (SF_CANBUSTWALLS | SF_MULTIABILITY)
				if player.hyper == nil or not player.hyper.capable then
					player.acceleration = (skins[player.mo.skin].acceleration * 4) / 3
					player.thrustfactor = (skins[player.mo.skin].thrustfactor * 61) / 51
					if player.xpsuper then player.mo.color = SKINCOLOR_SKY end
				elseif player.hyper.capable then
					if player.cpanel > 0 then
						player.acceleration = (skins[player.mo.skin].acceleration * 2)
						player.thrustfactor = (skins[player.mo.skin].thrustfactor * 4)
					else
						player.acceleration = (skins[player.mo.skin].acceleration * 3) / 2
						player.thrustfactor = (skins[player.mo.skin].thrustfactor * 7) / 4
					end
					if player.xpsuper then player.mo.color = SKINCOLOR_AZURE end
					if leveltime%3 == 1 then
						local afterimage = P_SpawnGhostMobj(player.mo)
						afterimage.flags = $ & ~MF_NOCLIPHEIGHT
						afterimage.destscale = player.mo.scale*32
						afterimage.scalespeed = (FRACUNIT/10)*(player.mo.scale/FRACUNIT)
					end
				end
			elseif (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1) then
				player.acceleration = (skins[player.mo.skin].acceleration * 3) / 2
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 4) / 3
				player.charflags = $ | SF_CANBUSTWALLS
				player.jumpfactor = skins[player.mo.skin].jumpfactor + (player.speed / 50)
				if leveltime%TICRATE == 1 and player.powers[pw_invulnerability] == 0 then P_GivePlayerRings(player, -1) end
				if leveltime%8 == 1 then
					local afterimage = P_SpawnGhostMobj(player.mo)
					afterimage.colorized = true
					afterimage.flags = $ & ~MF_NOCLIPHEIGHT
					afterimage.destscale = ((player.mo.scale*3)/2)*(player.mo.scale/FRACUNIT)
					local r = player.mo.radius/FRACUNIT
					local xy = (P_RandomRange(r, -r)*FRACUNIT)
					local z = (P_RandomKey(player.mo.height/FRACUNIT)*FRACUNIT)
					local smokey = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_SMOKE)
					smokey.colorized = true
					smokey.color = player.mo.color
					local xbox = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_WATERZAP)
				end
			end
		else
			player.charflags = $ & ~SF_MULTIABILITY // No extra jumps if not Super.
		end
		player.powers[pw_underwater] = 100*TICRATE // We already have machines underwater.
		player.powers[pw_spacetime] = 100*TICRATE // And it's cold in space.
		// No spikey with Force Shield.
		if (player.powers[pw_shield] & SH_FORCE) and not (player.powers[pw_shield] & SH_PROTECTSPIKE) then
			player.powers[pw_shield] = $ | (SH_PROTECTSPIKE)
		end
		if player.playerstate == PST_DEAD then
			player.cpanel = 0
			player.powers[pw_sneakers] = 0
			player.powers[pw_invulnerability] = 0
			P_RestoreMusic(player)
		end
		if player.mo.eflags & MFE_SPRUNG then
			if ((player.cpanel > 0 and player.playerstate == PST_LIVE) or player.defragment) then
				player.mo.momz = $*5/4
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				S_StartSound(player.mo, sfx_sprong)
				if player.defragment and not P_IsObjectOnGround(player.mo) then player.defragment = false end
			end
			player.cpucooler = true
			if isdebug.value then CONS_Printf(player, "Sprung, top speed trigger.") end
		elseif (player.powers[pw_justlaunched] != 0 and not (player.pflags & PF_JUMPED)) and not player.cpucooler then // Ran off a up-facing slope? Speed.
			player.cpucooler = true
			if isdebug.value then CONS_Printf(player, "Sloped up, top speed trigger.") end
		elseif (not (player.pflags & PF_APPLYAUTOBRAKE) and (player.pflags & PF_AUTOBRAKE)) // Auto-brake...
		or (not (player.pflags & PF_AUTOBRAKE) and not (player.pflags & PF_STARTJUMP)) // Or not...
		and (player.pflags & PF_JUMPED) and player.mo.state == S_PLAY_ROLL and not (P_IsObjectOnGround(player.mo) and player.cpucooler) then 
			player.cpucooler = true
			if isdebug.value then CONS_Printf(player, "Grabbable chain use(d), top speed trigger.") end
		end
		// Embrace the rainbow of the starman.
		if mariomode then
			if player.powers[pw_invulnerability] != 0 then
				// Kart has sparkles when invincible, so...
				if leveltime%2 == 1 and mobjscale.value == 1 then
					local r = player.mo.radius/FRACUNIT
					local xy = (P_RandomRange(r, -r)*FRACUNIT)
					local z = (P_RandomKey(player.mo.height/FRACUNIT))
					local sparkley = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_IVSP)
					sparkley.colorized = true
					sparkley.color = player.mo.color
					sparkley.scale = player.mo.scale
				end
				player.mo.colorized = true
			else
				player.mo.colorized = false
			end
		end
		if player.exiting > 0 then
			if player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT then
				if (player.exiting == (14*TICRATE)/5 + 1) then
					local flatulence = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
					flatulence.scale = 3 << FRACBITS
					S_StartSound(player.mo, sfx_fundie)
					player.legoislandcd = true
				end
				if player.legoislandcd then
					player.mo.flags2 = $ | MF2_DONTDRAW
					player.mo.state = S_PLAY_FACEPLANT
				end
			elseif P_PlayerInPain(player) and (player.exiting <= 10) then
				if (player.exiting == 10) then
					local flatulence = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
					flatulence.scale = 3 << FRACBITS
					S_StartSound(player.mo, sfx_fundie)
				end
				player.mo.flags2 = $ | MF2_DONTDRAW
				player.mo.momx = 0
				player.mo.momy = 0
				player.mo.momz = 0
			elseif (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT
			or player.mo.state == S_PLAY_EDGE) and player.powers[pw_super] == 0 then player.mo.state = S_WIN_CLR end
			if player.mo.state == S_WIN_CLR1 and player.powers[pw_super] == 0 and not player.tada98 then
				S_StartSound(player.mo, sfx_win98t)
				player.tada98 = true
			end
		end
		if player.formnet > 0 then
			player.formnet = $ - 1
		elseif player.formnet < 0 then
			player.formnet = 0
		else
			player.formnet = 0
		end
		if player.threeone == nil then player.threeone = false
		elseif player.threeone and not (player.cmd.buttons & BT_CUSTOM3) then player.threeone = false
		end
		// Transform as long as you have rings and emeralds,
		// regardless of a shield being present while having not used character ability/shield.
		if player.cmd.buttons == (BT_CUSTOM3 | BT_JUMP) and player.exiting == 0
		and (player.powers[pw_super] == 0 or (player.solchar and player.solchar.istransformed and player.solchar.istransformed == 0))
		and player.formnet == 0 and not (player.pflags & PF_THOKKED) and not player.mo.boat then
			if player.rings >= 50 and player.solchar and player.solchar.hasallemeralds and player.solchar.istransformed != 1
			and player.cmd.buttons & BT_CUSTOM3 and not player.threeone then
				player.solchar.istransformed = 1
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_secir)
				player.powers[pw_extralife] = 0
				player.solchar.emeraldcircle = 1
				player.threeone = true
			elseif ((player.solchar and player.solchar.istransformed == 1 and player.rings >= 50 and All7Emeralds(emeralds))
			or (player.rings >= 50 and All7Emeralds(emeralds) and not player.solchar != nil))
			and player.cmd.buttons & BT_CUSTOM3 and not player.threeone then
				if player.solchar then
					if player.solchar.istransformed > 1 then
						player.solchar.istransformed = 0
						local bskin = skins[player.skin]
						player.solchar.istransformed = 0
						player.solchar.solexception = false
						P_RestoreMusic(player)
						if not (bskin.flags & SF_RUNONWATER)
							player.charflags = $ & ~ SF_RUNONWATER
						end
						if not (bskin.flags & SF_NOSHIELDABILITY)
							player.charflags = $ & ~ SF_NOSHIELDABILITY
						end
						player.mo.eflags = $ & ~MFE_FORCESUPER
						player.mo.state = $
						player.charflags = $ | SF_SUPER
						if not player.isxmomentum
							player.normalspeed = bskin.normalspeed
						end
						player.runspeed = bskin.runspeed
						player.shieldscale = bskin.shieldscale
						player.mo.color = player.skincolor
						player.fakenormalspeed = bskin.normalspeed
						player.jumpfactor = bskin.jumpfactor
						player.solchar.earlyburncancel = true
						P_DoSuperTransformation(player, false)
						player.formnet = TICRATE
						player.pflags = $ & ~PF_JUMPED
					elseif player.SolTransforming != nil then
						player.CancelSolTransform = true
						player.charflags = $ | SF_SUPER
						player.mo.state = S_PLAY_STND
						P_DoSuperTransformation(player, false)
						player.mo.quitplayinsoundsjackass = true
						player.solchar.earlyburncancel = true
						player.SolTransforming = $ - 1
						player.formnet = TICRATE
						player.pflags = $ & ~PF_JUMPED
					else
						P_DoSuperTransformation(player, false)
						player.formnet = TICRATE
					end
				else
					P_DoSuperTransformation(player, false)
					player.formnet = TICRATE
					player.pflags = $ & ~PF_JUMPED
				end
				player.threeone = true
			end
		end
		if player.cmd.buttons == (BT_CUSTOM3 | BT_JUMP) and player.formnet == 0 then
			if not (player.powers[pw_super] != 0 or (player.solchar and player.solchar.istransformed > 1)) then return end
			if isdebug.value then CONS_Printf(player, "Attempting to detransform...") end
			S_StartSound(player.mo, sfx_s1a8)
			S_StartSound(player.mo, sfx_antiri)
			local cancel = P_SpawnGhostMobj(player.mo)
			cancel.destscale = player.mo.scale*32
			cancel.scalespeed = (player.mo.scale/6)*(player.mo.scale/FRACUNIT)
			if player.powers[pw_super] != 0 then
				player.powers[pw_super] = 0
				player.charflags = $ | SF_SUPER
				if isdebug.value then CONS_Printf(player, "Super off.") end
			end
			if player.solchar and player.solchar.istransformed > 1 then
				local bskin = skins[player.skin]
				player.solchar.istransformed = 0
				player.solchar.solexception = false
				P_RestoreMusic(player)
				if not (bskin.flags & SF_RUNONWATER)
					player.charflags = $ & ~ SF_RUNONWATER
				end
				if not (bskin.flags & SF_NOSHIELDABILITY)
					player.charflags = $ & ~ SF_NOSHIELDABILITY
				end
				player.mo.eflags = $ & ~MFE_FORCESUPER
				player.mo.state = $
				player.charflags = $ | SF_SUPER
				if not player.isxmomentum
					player.normalspeed = bskin.normalspeed
				end
				player.runspeed = bskin.runspeed
				player.shieldscale = bskin.shieldscale
				player.mo.color = player.skincolor
				player.fakenormalspeed = bskin.normalspeed
				player.jumpfactor = bskin.jumpfactor
				player.solchar.earlyburncancel = true
				player.mo.blasstransformextra = 0
				player.mo.blasstransforminc = 0
				player.formnet = TICRATE
				player.pflags = $ & ~PF_JUMPED
				if isdebug.value then CONS_Printf(player, "Blazing off.") end
			end
			player.mo.color = player.skincolor
			player.formnet = TICRATE
			player.pflags = $ & ~PF_JUMPED
			player.pflags = $ | PF_THOKKED
			P_GivePlayerRings(player, -5)
			P_RestoreMusic(player)
			P_SpawnShieldOrb(player)
			if player.mo.state == S_PLAY_STND then player.mo.sprite2 = SPR2_STND end
			if player.cpanel > 0 then player.cpanel = (2*$/5) end
		end
		if player.mo.boat then
			if player.powers[pw_super] != 0 then
				player.powers[pw_super] = 0
				local watercool = P_SpawnGhostMobj(player.mo)
				watercool.destscale = player.mo.scale*32
				watercool.scalespeed = (player.mo.scale/6)*(player.mo.scale/FRACUNIT)
				S_StartSound(player.mo, sfx_s1a8)
				S_StartSound(player.mo, sfx_antiri)
				P_ResetPlayer(player)
				P_SpawnShieldOrb(player)
				player.mo.color = player.skincolor
			end
		end
		if player.isjumphold and not (player.cmd.buttons & BT_JUMP) then player.isjumphold = false end
		if player.sparkspawn and P_PlayerInPain(player) and leveltime%3 == 1 then
			for i = 0,5,1
				local r = player.mo.radius/FRACUNIT
				local xy = (P_RandomRange(r, -r)*FRACUNIT)
				local z = (P_RandomKey(player.mo.height/FRACUNIT)*FRACUNIT)
				P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_WATERZAP)
			end
		elseif player.sparkspawn and not P_PlayerInPain(player) then
			player.sparkspawn = false
		end
		if player.mrce then
			player.mrce.customskin = 2
			if gamemap == 164 and not netgame and player.powers[pw_super] and player.xpsuper then
				if player.playerstate == 0 or player.playerstate == 2 then player.mo.color = SKINCOLOR_NEWERAPC
				else player.mo.color = player.skincolor end
			end
		end
	end
end)

// Annoying bubbles stop momentum...
addHook("TouchSpecial", function(bubble, grabber)
	if bubblegrief.value == 0 then return true end
	if (grabber and grabber.valid) and grabber.skin == "windows" then
		S_StartSound(grabber, sfx_mmepop)
		P_KillMobj(bubble)
		return true
	end
end, MT_EXTRALARGEBUBBLE)

addHook("MapLoad", function(gamemap)
	if mapheaderinfo[gamemap].nextlevel == 1103 then cobalt = true else cobalt = false end
	if gamemap == 164 and not netgame then
		for player in players.iterate
			if player.mo and player.mo.valid and player.mo.skin == "windows" then
				if player.mrce then
					if gamemap == 164 and not netgame then
						hellomrce = true
						if ((player.isxmomentum and not player.xmomtoggledoff) and not (player.hyper and player.hyper.capable)) and player.powers[pw_super] > 0 then
							player.rings = 95
							if player.isxmomentum and player.hyper and not player.hyper.capable then
								player.hyper.capable = true
							end
						end
					end
				else
					hellomrce = false
				end
			end
		end
	end
end)

// Script by Katmint.
// Edited w/ variable check.
// Still buggy, still here.

addHook("MusicChange", function(oldname, newname)
	if newname == "_title" and mplayer.value then
		return "RUNDLL"
	end
	if consoleplayer then
		local character = skins[consoleplayer.skin].name
		if character == "windows" then
			if newname == "_super" and consoleplayer.powers[pw_super] != 0 and mplayer.value != 0 then
				if consoleplayer.isxmomentum != nil and consoleplayer.hyper and consoleplayer.hyper.capable then
					return "HYPWIN"
				else
					return "SUPWIN"
				end
			elseif newname == "_inv" and consoleplayer.powers[pw_invulnerability] != 0 then
				S_StartMusicCaption("Invincibility", consoleplayer.powers[pw_invulnerability], consoleplayer)
				if mariomode and mplayer.value != 0 then
					return "KINV"
				elseif not mariomode and mplayer.value != 0
					return "WINV"
				elseif mariomode and mplayer.value == 0
					return "_MINV"
				else
					return "_inv"
				end
			elseif newname == "_shoes" and consoleplayer.powers[pw_sneakers] != 0 then
				if mobjscale.value == 1 then
					S_StartMusicCaption("Growth Powerup", consoleplayer.powers[pw_sneakers], consoleplayer)
					if mariomode then return "KGROWM" else return "KGROW" end
				elseif mplayer.value != 0 then
					S_StartMusicCaption("Speed Shoes", consoleplayer.powers[pw_sneakers], consoleplayer)
					return "WINFAST"
				end
			elseif newname == "HYPR" and consoleplayer.powers[pw_super] != 0 and mplayer.value != 0 then
				return "HYPWIN"
			elseif newname == "_clear" then
				if mplayer.value != 0 then
					if cobalt then
						return "DIALER"
					elseif consoleplayer.gotcontinue then
						return "WINGOT"
					else
						return "WINCLR"
					end
				end
			elseif newname == "_conti" then
				return "WINCON"
			elseif newname == "_1up" then
				S_StartSound(consoleplayer.mo, sfx_spslri, consoleplayer)
				return
			elseif oldname == "_1up" then
				if consoleplayer.powers[pw_sneakers] != 0 and mobjscale.value then
					S_StartMusicCaption("Growth Powerup", consoleplayer.powers[pw_sneakers], consoleplayer)
					if mariomode then return "KGROWM" else return "KGROW" end
				elseif consoleplayer.powers[pw_sneakers] != 0 and not mobjscale.value and not mplayer.value then
					S_StartMusicCaption("Speed Shoes", consoleplayer.powers[pw_sneakers], consoleplayer)
					return "_shoes"
				elseif consoleplayer.powers[pw_sneakers] != 0 and mplayer.value then
					S_StartMusicCaption("Speed Shoes", consoleplayer.powers[pw_sneakers], consoleplayer)
					return "WINFAST"
				elseif consoleplayer.powers[pw_invulnerability] != 0 then
					S_StartMusicCaption("Invincibility", consoleplayer.powers[pw_invulnerability], consoleplayer)
					if mariomode and mplayer.value != 0 then
						return "KINV"
					elseif not mariomode and mplayer.value != 0
						return "WINV"
					elseif mariomode and mplayer.value == 0
						return "_MINV"
					else
						return "_inv"
					end
				end
			end
		end
	end
end)

addHook("MobjMoveCollide", function(bee, win)
	if win and win.valid and win.player and win.player.valid and win.skin == "windows" and not P_PlayerInPain(win.player) and win.player.powers[pw_flashing] == 0
	and bee and bee.valid and not (win.z > bee.z+(6*bee.height/5)) and not (bee.z > win.z+(6*win.height/5)) then
		if P_PlayerCanDamage(win.player, bee) or win.player.powers[pw_invulnerability] != 0 then
			return
		end
		if win.player.powers[pw_shield] & SH_ARMAGEDDON then
			P_BlackOw(win.player)
		end
		P_DoPlayerPain(win.player)
		S_StartSound(win, sfx_s3k37)
		S_StartSound(win, sfx_s3k79)
		P_DamageMobj(bee, win, win)
		win.player.sparkspawn = true
		return true
	end
end, MT_BUMBLEBORE)

addHook("MobjMoveCollide", function(win, bee)
	if win and win.valid and win.player and win.player.valid and win.skin == "windows" and not P_PlayerInPain(win.player) and win.player.powers[pw_flashing] == 0
	and bee and bee.valid and bee.type == MT_BUMBLEBORE and not (win.z > bee.z+(6*bee.height/5)) and not (bee.z > win.z+(6*win.height/5)) then
		if P_PlayerCanDamage(win.player, bee) or win.player.powers[pw_invulnerability] != 0 then
			return
		end
		if win.player.powers[pw_shield] & SH_ARMAGEDDON then
			P_BlackOw(win.player)
		end
		P_DoPlayerPain(win.player)
		S_StartSound(win, sfx_s3k37)
		S_StartSound(win, sfx_s3k79)
		P_DamageMobj(bee, win, win)
		win.player.sparkspawn = true
		return true
	end
end, MT_PLAYER)

if not boatchars
	rawset(_G, "boatchars", {})
end
boatchars["windows"] = {1, 0, 0}